
// dll    
#import "statistik.dll"
 bool NewExpert(string  isBrokerName, string isInstrument, int Digit);   // 
 bool NewDeal(string isInstrument, int Action,int magik, double PriceOpen, int Slippage, int TimeForOpen,
               int Requotes);
 bool CloseDeal( string isInstrument,int magik,double PriceClose, int Slippage, int TimeForClose,
                  int Requotes);
#import

extern int Num_Deals=3;

extern int TimeInMarket=4;

//   
int       slippage = 10;
//    
int TimeForSleep = 10;
// 
int time_for_action = 1;
//  / 
int count = 5;

//  
bool isNewBar()
  {
  static datetime BarTime;
   bool res=false; 
   if (BarTime!=Time[0]) 
      {
         BarTime=Time[0];  
         res=true;
      } 
   return(res);
  }
//+------------------------------------------------------------------+
//|  magik                                                  |
//+------------------------------------------------------------------+ 
int GenericMagik()
{
int deals;

   for(int i=OrdersTotal()-1;i>=0;i--) 
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if (OrderSymbol()==Symbol())
            if (OrderMagicNumber()!=0)
               deals++;
   }
             
   return (deals);
}

//+------------------------------------------------------------------+   
//  
//+------------------------------------------------------------------+
bool CloseOrder(int magik)
{
   int ticket,i;
   double Price_close;
   int count=0;
   datetime begin_time;
   double Real_close;
       
   begin_time=TimeCurrent();    
   for(i=OrdersTotal()-1;i>=0;i--) 
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if (OrderSymbol()==Symbol()) 
            if(OrderMagicNumber()==magik)
            {                  
               while(count<10)
               {                       
                  if(OrderType()==OP_BUY)        
                     Price_close=NormalizeDouble(Bid,Digits);
                  if(OrderType()==OP_SELL)        
                     Price_close=NormalizeDouble(Ask,Digits);
                                       
                  if(OrderClose(OrderTicket(),OrderLots(),Price_close,slippage))
                     { 
                           Real_close=OrderClosePrice();
                           CloseDeal(Symbol(),magik,Real_close,MathAbs(Real_close-Price_close),
                            (TimeCurrent()-begin_time),count);                                                         
                           return (true);
                     }
                  count++;                      
                  Sleep(5000);
                  RefreshRates();                                               
               }                                          
            }
   }
return(false); 
}

//+------------------------------------------------------------------+
//|  act 1-, 2-,   - -        |
//+------------------------------------------------------------------+ 
int Deal(int act, double Lot)
  {
   int N = 0;
   int ticket;
   int err;
   double Price_open;
   double Real_price;
   datetime begin_deal;
   double Lots;
   int cmd;
   int magik;
   magik = GenericMagik()+1;   
   Lots = NormalizeDouble(Lot,1);
   //    
   AccountFreeMarginCheck(Symbol(), cmd,Lots);
   err = GetLastError();
   if(err>0)
     {
       Print("No money for new position");
       return(0);
     }      
     
    begin_deal=TimeCurrent(); 
     
       while(N < count)
         {
            if(act == 1)
            {
               Price_open = NormalizeDouble(Ask, Digits);
               cmd = OP_BUY;
            }
            
            if(act == 2)
            {
               Price_open = NormalizeDouble(Bid, Digits);
               cmd = OP_SELL;
            }
                                   Print("OPEN ORDER"); 
            ticket = OrderSend(Symbol(), cmd, Lots, Price_open,
                                  slippage, 0, 0, 0, magik);
             if(ticket > 0)
                 {
                   if (OrderSelect(ticket,SELECT_BY_TICKET)==true)
                   {
                   Real_price=OrderOpenPrice();
                   Print("Write Open Data");
                   NewDeal(Symbol(), cmd,magik,Real_price ,MathAbs(Real_price-Price_open),
                     (TimeCurrent()-begin_deal), N);
                   }                   
                   return(ticket);
                 }
            N++;                                        
            Sleep(5000);
            RefreshRates();                                              
         }                                                           
   return(0);
  }
//+------------------------------------------------------------------+
//|    /   Macd       |
//+------------------------------------------------------------------+
int GetAction(int &action, double &lot, int &magik)
   {
   int cnt,total;
         
      if (OrdersTotal()<= Num_Deals)
      {
         if (Close[1]>Close[2])
         {
            action=1;
            lot=1;
            return (0);
         }
         if(Close[2]<Close[1])
         {
            action=2;
            lot=1;         
            return (0);               
         }
      }
      
   total=OrdersTotal();
   for(cnt=total-1;cnt>=0;cnt--)
     {
      if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
         if  (OrderSymbol()==Symbol())  
             if ((TimeCurrent()-OrderOpenTime())>TimeInMarket*60)
                {
                  action=3;
                  magik=OrderMagicNumber();
                  return(0); 
                }

     }
   }
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
  int Digit;
  if(IsDllsAllowed()==false)
    {
      Print("   (DLL) .    .");
      return(0);
    }
    
  if(!IsTradeAllowed())
  {
      Print("   !");
      return(0);     
  }

  Digit=MarketInfo(Symbol(),MODE_DIGITS);
  if ((Digit>0) && (Bid > 0))
  {  
   if (!NewExpert(AccountServer( ) , Symbol(), Digit))
      {
         Print("    ");
         return (0);
      }
      		 		       
       Print("   ");                    
   return(0);      
  }   
   Print("   MarketInfo!");       
   return(0);  
 }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   int action =0;
   double lot = 1;
   int magik = 0;     
   while(!IsStopped())
     {
       Sleep(time_for_action*1000);      
       RefreshRates();
       if (isNewBar())
       {
         GetAction(action,lot,magik);

           if(((action == 1) || (action == 2)))
             {                                        
               if (IsTradeAllowed())
                  Deal(action, lot);
               Sleep(TimeForSleep*1000);                                

             }
           if(action == 3)
             {
                if (IsTradeAllowed())
                  if(!CloseOrder(magik))
                     {
                       Print("   ");
                       Sleep(TimeForSleep*1000);   
                     } 
             }
       action = 0;
       lot = 0;
       magik = 0;
       }
     }
   Print("       ");  
   return(0);
  }
//+------------------------------------------------------------------+